## antpm 1.16

=== CMakeLists.txt ===
# -*- mode: cmake; coding: utf-8-dos -*-
CMAKE_MINIMUM_REQUIRED(VERSION 2.8.2)
IF(COMMAND CMAKE_POLICY)
  CMAKE_POLICY(SET CMP0003 NEW)
ENDIF(COMMAND CMAKE_POLICY)


PROJECT(antpm C CXX)

OPTION(USE_COVERAGE "use gcov" FALSE)
OPTION(USE_BOOST_TEST "use boost::test" FALSE)
OPTION(USE_BOOST_STATIC_LINK "link statically against boost" TRUE)


SET(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/cmake/")

# Set a default build type for single-configuration
# CMake generators if no build type is set.
IF(NOT CMAKE_CONFIGURATION_TYPES AND NOT CMAKE_BUILD_TYPE)
   SET(CMAKE_BUILD_TYPE Debug)
ENDIF(NOT CMAKE_CONFIGURATION_TYPES AND NOT CMAKE_BUILD_TYPE)
MESSAGE(STATUS "CMAKE_BUILD_TYPE=${CMAKE_BUILD_TYPE}")
MESSAGE(STATUS "CMAKE_CONFIGURATION_TYPES=${CMAKE_CONFIGURATION_TYPES}")

set(CMAKE_CXX_FLAGS_RELEASE        "${CMAKE_CXX_FLAGS_RELEASE} -DNDEBUG=1")
set(CMAKE_C_FLAGS_RELEASE          "${CMAKE_C_FLAGS_RELEASE} -DNDEBUG=1")

IF(MSVC)
	IF(NOT DEP_ROOT)
		SET(DEP_ROOT "DEP_ROOT-NOTFOUND" CACHE PATH "dependency root path")
	ENDIF()
	SET(LIBUSB_ROOT "${CMAKE_SOURCE_DIR}\\..\\3rd_party\\libusb-win32-bin-1.2.6.0\\")
	SET(BOOST_ROOT "${DEP_ROOT}\\boost_1_43_0" CACHE PATH "Boost PATH" )

  SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /MP")
  SET(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} /MD")
  ADD_DEFINITIONS(-D_CRT_SECURE_NO_WARNINGS)
ENDIF()

IF(CMAKE_COMPILER_IS_GNUCXX)
  set(CMAKE_CXX_FLAGS                "${CMAKE_CXX_FLAGS} -fpermissive  -fms-extensions -std=c++0x -Wall")
  SET(CMAKE_CXX_FLAGS_RELWITHDEBINFO "${CMAKE_CXX_FLAGS_RELWITHDEBINFO} -O2 -g")
  SET(CMAKE_CXX_FLAGS_RELEASE        "${CMAKE_CXX_FLAGS_RELEASE} -O2")
  set(CMAKE_CXX_FLAGS_DEBUG          "${CMAKE_CXX_FLAGS_DEBUG} -O0 -g3 -ggdb3")
  set(CMAKE_C_FLAGS                  "${CMAKE_C_FLAGS} -pedantic -Wextra -Wall")
  set(CMAKE_C_FLAGS_DEBUG            "${CMAKE_C_FLAGS_DEBUG} -g3 -ggdb3")

  IF(USE_COVERAGE)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fprofile-arcs -ftest-coverage")
    set(CMAKE_EXE_LINKER_FLAGS
      "${CMAKE_EXE_LINKER_FLAGS} -fprofile-arcs -ftest-coverage")
  ENDIF()
ENDIF()

INCLUDE(FindLIBUSB)
IF(NOT LIBUSB_FOUND)
  MESSAGE(FATAL_ERROR "Could not find LIBUSB")
ENDIF()

IF(USE_BOOST_STATIC_LINK)
  set(Boost_USE_STATIC_LIBS        ON)
ELSE()
  set(Boost_USE_STATIC_LIBS        OFF)
ENDIF()
set(Boost_USE_MULTITHREADED      ON)
set(Boost_USE_STATIC_RUNTIME    OFF)
FIND_PACKAGE(Boost 1.41.0 COMPONENTS thread unit_test_framework program_options system filesystem date_time REQUIRED)
IF(NOT Boost_FOUND)
  MESSAGE(FATAL_ERROR "Boost not found!")
ENDIF()


INCLUDE_DIRECTORIES(.)
INCLUDE_DIRECTORIES(${Boost_INCLUDE_DIR})
INCLUDE_DIRECTORIES(${LIBUSB_INCLUDE_DIRS})

LINK_DIRECTORIES(${Boost_LIBRARY_DIRS})

IF(MSVC)
  ADD_DEFINITIONS(-D_CRT_NONSTDC_NO_WARNINGS)
  #set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} /NODEFAULTLIB:libboost_date_time-vc90-mt-s-1_43.lib /NODEFAULTLIB:libboost_thread-vc90-mt-s-1_43.lib /NODEFAULTLIB:libboost_program_options-vc90-mt-s-1_43.lib /NODEFAULTLIB:libboost_filesystem-vc90-mt-s-1_43.lib /NODEFAULTLIB:libboost_system-vc90-mt-s-1_43.lib")
ENDIF()

FILE(READ "${PROJECT_SOURCE_DIR}/VERSION" ANTPM_VERSION)
MESSAGE(STATUS "ANTPM_VERSION=\\\"${ANTPM_VERSION}\\\"")
ADD_DEFINITIONS(-DANTPM_VERSION=${ANTPM_VERSION})

SET(SRCS
  antdefs.hpp antdefs.cpp
  SmartPtrFwd.hpp   w_inttypes.h w_stdint.h stdintfwd.hpp
  common.hpp common.cpp
  AntMessage.hpp AntMessage.cpp
  AntChannel.hpp   AntChannel.cpp
  AntMessenger.hpp AntMessenger.cpp
  SerialUsb.hpp SerialUsb.cpp
  AntFr310XT.hpp AntFr310XT.cpp
  AntFr405.hpp AntFr405.cpp
  lqueue.hpp
  Serial.hpp Serial.cpp

  FIT.hpp FIT.cpp
  GPX.hpp GPX.cpp
  GarminConvert.hpp GarminConvert.cpp
  GarminPacketIntf.hpp GarminPacketIntf.cpp

  DeviceSettings.hpp DeviceSettings.cpp

  Log.hpp
  LazySingleton.hpp

  VERSION
)
IF(NOT WIN32)
  SET(SRCS
	  ${SRCS}
    SerialTty.hpp SerialTty.cpp
	  )
  SET(Boost_THREAD_LIBRARY "${Boost_THREAD_LIBRARY};pthread")
ENDIF()


ADD_LIBRARY(antpm
  ${SRCS}
)
TARGET_LINK_LIBRARIES(antpm
  ${Boost_DATE_TIME_LIBRARY}
  ${LIBUSB_LIBRARIES}
  ${Boost_THREAD_LIBRARY}
  ${Boost_SYSTEM_LIBRARY}
  ${Boost_FILESYSTEM_LIBRARY}
  stdc++
)

ADD_EXECUTABLE(antpm-usbmon2ant
  antpm-usbmon2ant.cpp
)
TARGET_LINK_LIBRARIES(antpm-usbmon2ant
  antpm
  ${Boost_PROGRAM_OPTIONS_LIBRARY}
)
INSTALL(TARGETS antpm-usbmon2ant RUNTIME DESTINATION bin)


ADD_EXECUTABLE(antpm-downloader
  antpm-downloader.cpp
)
TARGET_LINK_LIBRARIES(antpm-downloader
  antpm
  ${Boost_PROGRAM_OPTIONS_LIBRARY}
)
INSTALL(TARGETS antpm-downloader RUNTIME DESTINATION bin)


ADD_EXECUTABLE(antpm-fit2gpx
  antpm-fit2gpx.cpp
)
TARGET_LINK_LIBRARIES(antpm-fit2gpx
  antpm
  ${Boost_PROGRAM_OPTIONS_LIBRARY}
)
INSTALL(TARGETS antpm-fit2gpx RUNTIME DESTINATION bin)

add_custom_target(dist COMMAND ${CMAKE_MAKE_PROGRAM} package_source)

ADD_SUBDIRECTORY(gant)

# set(CPACK_PACKAGE_VERSION_MAJOR "1")
# set(CPACK_PACKAGE_VERSION_MINOR "0")
# set(CPACK_SOURCE_GENERATOR "TGZ")
# set(CPACK_SOURCE_PACKAGE_FILE_NAME "${CMAKE_PROJECT_NAME}-${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}-src")
# MESSAGE(STATUS "${CPACK_SOURCE_IGNORE_FILES}")
# set(CPACK_SOURCE_IGNORE_FILES
#   "/build/;/.bzr/;~$;${CPACK_SOURCE_IGNORE_FILES};/CMakeLists.txt.user;/gpsbabel/;/gtest-1.6.0/")
# set(CPACK_DEBIAN_PACKAGE_MAINTAINER "Kristof Ralovich <tade60@freemail.hu>")
# set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "ANT+minus")
# set(CPACK_PACKAGE_DESCRIPTION "Userspace implementation of a wire protocol similar to the ANT/ANT+ protocols. The goal is to be able to communicate with the Forerunner 310XT watch, in order to retrieve sports tracks. Communication with other watches might work, please report your experiences to improve the software.")
# set(CPACK_DEBIAN_PACKAGE_DEPENDS "libstdc++6 (>=4.6.0)")
# #set(CPACK_DEBIAN_PACKAGE_DEPENDS "libstdc++6 (>=4.6.0), cmake, debhelper (>= 7), libboost-filesystem, libboost-system")
# #set(CPACK_DEBIAN_PACKAGE_CONTROL_EXTRA 	This variable allow advanced user to add custom script to the control.tar.gz (inside the .deb archive) 	${CMAKE_CURRENT_SOURCE_DIR}/postinst
# #set(CPACK_DEBIAN_PACKAGE_SECTION 	Package section (see http://packages.debian.org/stable/) 	Network
# #set(CPACK_DEBIAN_PACKAGE_VERSION 	Package version 	${CPACK_PACKAGE_VERSION}+lenny1
# INCLUDE(CPack)

IF(USE_BOOST_TEST)

  if(${VALGRIND_PREFIX})
    message(STATUS "Valgrind Prefix: ${VALGRIND_PREFIX}")
  endif()
  find_program(VALGRIND_PROGRAM NAMES valgrind PATH /usr/bin /usr/local/bin ${VALGRIND_PREFIX}/bin)
  IF(VALGRIND_PROGRAM)
    message(STATUS "Found Valgrind: ${VALGRIND_PROGRAM}")
    SET(MEMORYCHECK_COMMAND:FILEPATH=${VALGRIND_PROGRAM})
    # You can add additional options by specifying MEMORYCHECK_COMMAND_OPTIONS and MEMORYCHECK_SUPPRESSIONS_FILE. 
  ENDIF()

  enable_testing()
  ADD_SUBDIRECTORY(tests)
ENDIF()

=== tests/CMakeLists.txt ===
ADD_DEFINITIONS(-DUSE_BOOST_TEST=1)
ADD_DEFINITIONS(-DTEST_ROOT=\"${CMAKE_CURRENT_SOURCE_DIR}\")
MESSAGE(STATUS "TEST_ROOT=\"${CMAKE_CURRENT_SOURCE_DIR}\"")

ADD_EXECUTABLE(testDeviceSettings
  testDeviceSettings.cpp
)
TARGET_LINK_LIBRARIES(testDeviceSettings
  antpm
  ${Boost_PROGRAM_OPTIONS_LIBRARY}
  ${Boost_UNIT_TEST_FRAMEWORK_LIBRARY}
)

ADD_EXECUTABLE(testDateTime
  testDateTime.cpp
)
TARGET_LINK_LIBRARIES(testDateTime
  antpm
  ${Boost_PROGRAM_OPTIONS_LIBRARY}
  ${Boost_UNIT_TEST_FRAMEWORK_LIBRARY}
)



IF(VALGRIND_PROGRAM)
  function(add_my_test name binary)
    #set(memcheck_command "${CMAKE_MEMORYCHECK_COMMAND} ${CMAKE_MEMORYCHECK_COMMAND_OPTIONS}")
    #separate_arguments(memcheck_command)
    add_test(${name} ${binary} ${ARGN})
    add_test(memcheck_${name} ${VALGRIND_PROGRAM} --leak-check=full ./${binary} ${ARGN})
  endfunction()

  function(set_memcheck_test_properties name)
    set_tests_properties(${name} ${ARGN})
    set_tests_properties(memcheck_${name} ${ARGN})
  endfunction()
ELSE()
  function(ADD_MY_TEST name binary)
    add_test(${name} ${binary} ${ARGN})
  endfunction()
ENDIF()

ADD_MY_TEST(testDeviceSettings1 testDeviceSettings)

ADD_MY_TEST(testDateTime1 testDateTime)

ADD_MY_TEST(testDeviceSettings2 testDeviceSettings --help)

ADD_MY_TEST(testDateTime2 testDateTime --help)

ADD_MY_TEST(testDownload ../antpm-downloader)

ADD_MY_TEST(testFit2Gpx ../antpm-fit2gpx)

ADD_MY_TEST(testUsbmon2AntParse  ../antpm-usbmon2ant --op parse  ${CMAKE_CURRENT_SOURCE_DIR}/2012_12_21_antagent1.usbmon)
ADD_MY_TEST(testUsbmon2AntDump   ../antpm-usbmon2ant --op dump   ${CMAKE_CURRENT_SOURCE_DIR}/2012_12_21_antagent1.usbmon)
ADD_MY_TEST(testUsbmon2AntUsbmon ../antpm-usbmon2ant --op usbmon ${CMAKE_CURRENT_SOURCE_DIR}/2012_12_21_antagent1.usbmon)
ADD_MY_TEST(testUsbmon2AntFilter ../antpm-usbmon2ant --op filter ${CMAKE_CURRENT_SOURCE_DIR}/2012_12_21_antagent1.usbmon)
ADD_MY_TEST(testUsbmon2AntCount  ../antpm-usbmon2ant --op count  ${CMAKE_CURRENT_SOURCE_DIR}/2012_12_21_antagent1.usbmon)

=== debian/changelog ===
antpm (1.16-8) unstable; urgency=low

  * Team upload

  [ RALOVICH, Kristof ]
  * fix FTBFS under kfreebsd, tested in virtual machine

 -- Kristof Ralovich <ralovich@in.tum.de>  Sat, 16 Aug 2014 20:06:28 +0200

antpm (1.16-7) unstable; urgency=low

  * Team upload

  [ RALOVICH, Kristof ]
  * really link against boost_atomic
    Closes: #757472

 -- Kristof Ralovich <ralovich@in.tum.de>  Mon, 11 Aug 2014 11:40:58 +0200

antpm (1.16-6) unstable; urgency=low

  * Team upload

  [ RALOVICH, Kristof ]
  * link against boost_atomic
    Closes: #757472

 -- Kristof Ralovich <ralovich@in.tum.de>  Sat, 09 Aug 2014 15:18:44 +0200

antpm (1.16-5) unstable; urgency=low

  * Team upload

  [ RALOVICH, Kristof ]
  * debian/rules: do not call make -j0
  * debian: patch for kfreebsd builds

 -- Kristof Ralovich <ralovich@in.tum.de>  Sat, 02 Aug 2014 16:55:50 +0200

antpm (1.16-4) unstable; urgency=low

  [ RALOVICH, Kristof ]
  * re-upload after deletion of previous version

 -- Christian Perrier <bubulle@debian.org>  Wed, 21 May 2014 07:06:24 +0200

antpm (1.16-3) unstable; urgency=low

  * Team upload

  [ RALOVICH, Kristof ]
  * debian/rules: make sure debian/antpm.manpages points to existing files
    Closes: #745444

 -- Christian Perrier <bubulle@debian.org>  Mon, 28 Apr 2014 09:19:16 +0200

antpm (1.16-2) unstable; urgency=low

  * Team upload

  [ RALOVICH, Kristof ]
  * fix kFreebsd,Hurd FTBFS
  * don't provide garmin-ant-downloader package for now
  * rename garmin-ant-downloader to antpm-garmin-ant-downloader
  * build antpm-dbg package too

 -- Christian Perrier <bubulle@debian.org>  Tue, 08 Apr 2014 06:57:24 +0200

antpm (1.16-1) unstable; urgency=low

  * Team upload

  [ RALOVICH, Kristof ]
  * Merge tag 'upstream/20140302'
  * debian/copyright: document removal of GPLv2 only code

 -- Christian Perrier <bubulle@debian.org>  Wed, 19 Mar 2014 07:00:02 +0100

antpm (1.15-1) unstable; urgency=low

  [ RALOVICH, Kristof ]
  * Merge tag 'upstream/20140108'
  * debian/changelog is utf-8
  * debian/copyright: further clarification

 -- Christian Perrier <bubulle@debian.org>  Fri, 24 Jan 2014 18:53:44 +0100

antpm (1.14-1) unstable; urgency=low

  [ Christian Perrier ]
  * Release 1.14-1 with copyright clarifications from upstream
    (Kristof re-licensed his own code in GPL-3)
  * Bump debhelper compatibility to 9
  * Update Standards to 3.9.5 (checked)
  * Add gbp.conf to use gz compression for upstream tarball

  [ RALOVICH, Kristof ]
  * extend copyright file
  * update changelog too
  * refine debian/copyright

 -- Christian Perrier <bubulle@debian.org>  Tue, 07 Jan 2014 07:26:12 +0100

antpm (1.13-1) unstable; urgency=low

  [ RALOVICH, Kristof ]
  * Import upstream version v1.13. Including a fix for problem
    with _orig tarball, and initial identification of different
    watches, to tell the 310 and 405 apart.

  [ Noël Köthe ]
  * Additional a small patch for PROTOCOL_HELP.txt which would
    have helped me and might make it easier for other.;)

 -- Christian Perrier <bubulle@debian.org>  Fri, 13 Dec 2013 06:12:01 +0100

antpm (1.12-2) UNRELEASED; urgency=low

  [ Kristof Ralovich ]
  * pkg-config is also a Build-Depends

  [ Christian Perrier ]
  * Add required boost libraries to Build-Depends
  * Bump debhelper compatibility to 9
  * Update Standards to 3.9.5 (checked)

 -- Kristof Ralovich <ralovich@in.tum.de>  Tue, 15 Oct 2013 09:25:02 +0200

antpm (1.12-1) unstable; urgency=low

  * Initial release. Based on ANT+minus to supersede previous
    garmin-ant-downloader package.
    Closes: #690068

 -- Kristof Ralovich <ralovich@in.tum.de>  Mon, 14 Oct 2013 13:53:50 +0200


# Local Variables:
# coding: utf-8
# End:

=== debian/control ===
Source: antpm
Priority: optional
Section: utils
Maintainer: Debian running development group <pkg-running-devel@lists.alioth.debian.org>
Uploaders: Christian Perrier <bubulle@debian.org> 
Build-Depends: debhelper (>= 9~), devscripts (>= 2.10), g++ (>= 4.4) | clang (>= 3.0), libboost-dev (>= 1.41) | libboost1.41-dev, cmake (>= 2.8), libusb-dev, pkg-config (>= 0.25), libxml2-dev,libboost-thread-dev,libboost-filesystem-dev,libboost-system-dev,libboost-date-time-dev,libboost-program-options-dev,libboost-test-dev,libboost-atomic-dev
Standards-Version: 3.9.5
Vcs-Git: git://git.debian.org/git/pkg-running/antpm.git
Vcs-Browser: http://git.debian.org/?p=pkg-running/antpm.git;a=summary

Package: antpm
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libstdc++6 (>=4.4.0)
Description: ANT+ information retrieval client for Garmin GPS products
 This software uses the Garmin ANT+ proprietary USB keys and
 communication protocol to retrieve information (such as GPS traces)
 from some Garmin Forerunner watches such as Forerunner 405 and 310XT.
 .
 The underlying ANT+minus implements the ANT/ANT+/ANT-FS protocols to
 provide these tools: garmin-ant-downloader, antpm-downloader,
 antpm-fit2gpx, and antpm-usbmon2ant.
 .
 ANT+minus is a userspace implementation of a wire protocol similar
 to the ANT/ANT+/ANT-FS protocols. The goal is to be able to communicate
 with any ANT capable device in order to e.g. retrieve sports tracks. The
 c++ implementation is currently available under both linux and win.
 Communication with watches other than the 310XT might work, but are
 untested. Please report your experience to help improving the software. 
 .
 The software was originally named "gant" but renamed when packaged
 to avoid confusion with existing Java software.


Package: antpm-dbg
Section: debug
Priority: extra
Architecture: any
Depends:
 antpm (= ${binary:Version}),
 ${misc:Depends},
Description: ANT+ information retrieval client for Garmin GPS products
 This software uses the Garmin ANT+ proprietary USB keys and
 communication protocol to retrieve information (such as GPS traces)
 from some Garmin Forerunner watches such as Forerunner 405 and 310XT.
 .
 The underlying ANT+minus implements the ANT/ANT+/ANT-FS protocols to
 provide these tools: garmin-ant-downloader, antpm-downloader,
 antpm-fit2gpx, and antpm-usbmon2ant.
 .
 ANT+minus is a userspace implementation of a wire protocol similar
 to the ANT/ANT+/ANT-FS protocols. The goal is to be able to communicate
 with any ANT capable device in order to e.g. retrieve sports tracks. The
 c++ implementation is currently available under both linux and win.
 Communication with watches other than the 310XT might work, but are
 untested. Please report your experience to help improving the software. 
 .
 The software was originally named "gant" but renamed when packaged
 to avoid confusion with existing Java software.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# ifeq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
#   CFLAGS += -O2
# endif

export DH_VERBOSE=1

NUMCPUS=$(shell grep -c '^processor' /proc/cpuinfo)
ifeq ($(NUMCPUS),0)
		NUMCPUS=1
endif

CPPFLAGS:=$(shell dpkg-buildflags --get CPPFLAGS)
CFLAGS:=$(shell dpkg-buildflags --get CFLAGS) $(CPPFLAGS)
CXXFLAGS:=$(shell dpkg-buildflags --get CXXFLAGS) $(CPPFLAGS)
LDFLAGS:=$(shell dpkg-buildflags --get LDFLAGS)

%:
	dh $@

override_dh_auto_configure:
	mkdir cmake-build
	cd cmake-build && cmake ../src -DCMAKE_BUILD_TYPE=Release -DCMAKE_INSTALL_PREFIX=/usr -DCMAKE_C_FLAGS="${CMAKE_C_FLAGS} $(CFLAGS)" -DCMAKE_CXX_FLAGS="${CMAKE_CXX_FLAGS} $(CXXFLAGS)"

override_dh_auto_build:
	cd cmake-build && $(MAKE) -j$(NUMCPUS)

override_dh_strip:
	dh_strip --dbg-package=antpm-dbg
	dh_strip -s --remaining-packages

DESTDIR=../debian/antpm/
override_dh_install:
	cd cmake-build && $(MAKE) install DESTDIR=$(DESTDIR)
	mv debian/antpm/usr/bin/gant debian/antpm/usr/bin/antpm-garmin-ant-downloader
	cp scripts/80-ant-stick.rules debian/antpm.udev
	dh_installudev
	dh_install

## antpm 1.17

=== CMakeLists.txt ===
--- 
+++ 
@@ -10,7 +10,11 @@
 OPTION(USE_COVERAGE "use gcov" FALSE)
 OPTION(USE_BOOST_TEST "use boost::test" FALSE)
 OPTION(USE_BOOST_STATIC_LINK "link statically against boost" TRUE)
-
+IF(MSVC)
+  OPTION(USE_GANT "build gant" FALSE)
+ELSE()
+  OPTION(USE_GANT "build gant" TRUE)
+ENDIF()
 
 SET(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/cmake/")
 
@@ -35,6 +39,7 @@
   SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /MP")
   SET(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} /MD")
   ADD_DEFINITIONS(-D_CRT_SECURE_NO_WARNINGS)
+  ADD_DEFINITIONS(-D_WIN32_WINNT=0x0500)
 ENDIF()
 
 IF(CMAKE_COMPILER_IS_GNUCXX)
@@ -42,7 +47,7 @@
   SET(CMAKE_CXX_FLAGS_RELWITHDEBINFO "${CMAKE_CXX_FLAGS_RELWITHDEBINFO} -O2 -g")
   SET(CMAKE_CXX_FLAGS_RELEASE        "${CMAKE_CXX_FLAGS_RELEASE} -O2")
   set(CMAKE_CXX_FLAGS_DEBUG          "${CMAKE_CXX_FLAGS_DEBUG} -O0 -g3 -ggdb3")
-  set(CMAKE_C_FLAGS                  "${CMAKE_C_FLAGS} -pedantic -Wextra -Wall")
+  set(CMAKE_C_FLAGS                  "${CMAKE_C_FLAGS} -std=c99 -pedantic -Wextra -Wall")
   set(CMAKE_C_FLAGS_DEBUG            "${CMAKE_C_FLAGS_DEBUG} -g3 -ggdb3")
 
   IF(USE_COVERAGE)
@@ -94,7 +99,6 @@
   AntMessenger.hpp AntMessenger.cpp
   SerialUsb.hpp SerialUsb.cpp
   AntFr310XT.hpp AntFr310XT.cpp
-  AntFr405.hpp AntFr405.cpp
   lqueue.hpp
   Serial.hpp Serial.cpp
 
@@ -116,6 +120,7 @@
     SerialTty.hpp SerialTty.cpp
 	  )
   SET(Boost_THREAD_LIBRARY "${Boost_THREAD_LIBRARY};pthread")
+  SET(MY_ANTPM_LIBRARIES "stdc++")
 ENDIF()
 
 
@@ -128,7 +133,7 @@
   ${Boost_THREAD_LIBRARY}
   ${Boost_SYSTEM_LIBRARY}
   ${Boost_FILESYSTEM_LIBRARY}
-  stdc++
+  ${MY_ANTPM_LIBRARIES}
 )
 
 ADD_EXECUTABLE(antpm-usbmon2ant
@@ -162,7 +167,9 @@
 
 add_custom_target(dist COMMAND ${CMAKE_MAKE_PROGRAM} package_source)
 
-ADD_SUBDIRECTORY(gant)
+IF(USE_GANT)
+  ADD_SUBDIRECTORY(gant)
+ENDIF()
 
 # set(CPACK_PACKAGE_VERSION_MAJOR "1")
 # set(CPACK_PACKAGE_VERSION_MINOR "0")

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -20,6 +20,22 @@
   ${Boost_UNIT_TEST_FRAMEWORK_LIBRARY}
 )
 
+
+ADD_EXECUTABLE(sm1
+  sm1.cpp
+)
+TARGET_LINK_LIBRARIES(sm1
+  antpm
+  ${Boost_UNIT_TEST_FRAMEWORK_LIBRARY}
+)
+
+ADD_EXECUTABLE(lq1
+  lq1.cpp
+)
+TARGET_LINK_LIBRARIES(lq1
+  antpm
+  ${Boost_UNIT_TEST_FRAMEWORK_LIBRARY}
+)
 
 
 IF(VALGRIND_PROGRAM)
@@ -57,3 +73,7 @@
 ADD_MY_TEST(testUsbmon2AntUsbmon ../antpm-usbmon2ant --op usbmon ${CMAKE_CURRENT_SOURCE_DIR}/2012_12_21_antagent1.usbmon)
 ADD_MY_TEST(testUsbmon2AntFilter ../antpm-usbmon2ant --op filter ${CMAKE_CURRENT_SOURCE_DIR}/2012_12_21_antagent1.usbmon)
 ADD_MY_TEST(testUsbmon2AntCount  ../antpm-usbmon2ant --op count  ${CMAKE_CURRENT_SOURCE_DIR}/2012_12_21_antagent1.usbmon)
+
+
+ADD_MY_TEST(testsm1 sm1)
+ADD_MY_TEST(testlq1 lq1)

=== debian/changelog ===
antpm (1.17-2) unstable; urgency=low

  * Team upload

  [ Samuel Thibault ]
  * antpm: Fix nbcpu computation on non-linux
    Closes: #801578

 -- Kristof Ralovich <ralovich@in.tum.de>  Mon, 12 Oct 2015 20:54:34 +0200

antpm (1.17-1) unstable; urgency=low

  * Team upload

  [ RALOVICH, Kristof ]
  * New upstream version 1.17.
  * update to Standards-Version 3.9.6
  * drop patches merged upstream

 -- Kristof Ralovich <ralovich@in.tum.de>  Sat, 10 Oct 2015 00:48:41 +0200

antpm (1.16-9) unstable; urgency=low

  * Team upload

  [ RALOVICH, Kristof ]
  * Remove timestamp macro from source code to make package build reproducible.
    Original patch from Dhole <dhole@openmailbox.org>.
    Closes: #788754

 -- Kristof Ralovich <ralovich@in.tum.de>  Sun, 28 Jun 2015 12:58:40 +0200

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Maintainer: Debian running development group <pkg-running-devel@lists.alioth.debian.org>
 Uploaders: Christian Perrier <bubulle@debian.org> 
 Build-Depends: debhelper (>= 9~), devscripts (>= 2.10), g++ (>= 4.4) | clang (>= 3.0), libboost-dev (>= 1.41) | libboost1.41-dev, cmake (>= 2.8), libusb-dev, pkg-config (>= 0.25), libxml2-dev,libboost-thread-dev,libboost-filesystem-dev,libboost-system-dev,libboost-date-time-dev,libboost-program-options-dev,libboost-test-dev,libboost-atomic-dev
-Standards-Version: 3.9.5
+Standards-Version: 3.9.6
 Vcs-Git: git://git.debian.org/git/pkg-running/antpm.git
 Vcs-Browser: http://git.debian.org/?p=pkg-running/antpm.git;a=summary

=== debian/rules ===
--- 
+++ 
@@ -9,6 +9,9 @@
 
 NUMCPUS=$(shell grep -c '^processor' /proc/cpuinfo)
 ifeq ($(NUMCPUS),0)
+		NUMCPUS=1
+endif
+ifeq ($(NUMCPUS),)
 		NUMCPUS=1
 endif

## antpm 1.18

=== debian/changelog ===
antpm (1.18-2) unstable; urgency=low

  * Team upload

  [ RALOVICH, Kristof ]
  * cmake: don't static link boost
    Closes: #837399
  * debian: enable hardened build

 -- Kristof Ralovich <ralovich@in.tum.de>  Mon, 17 Oct 2016 19:34:00 +0200

antpm (1.18-1) unstable; urgency=low

  * Team upload

  [ RALOVICH, Kristof ]
  * New upstream version 1.18
  * update to Standards-Version 3.9.7
  * upgrade to libusb-1.0-0-dev package dependency
    Closes: #810395

 -- Kristof Ralovich <ralovich@in.tum.de>  Sat, 12 Mar 2016 23:06:34 +0100

=== debian/control ===
--- 
+++ 
@@ -3,9 +3,9 @@
 Section: utils
 Maintainer: Debian running development group <pkg-running-devel@lists.alioth.debian.org>
 Uploaders: Christian Perrier <bubulle@debian.org> 
-Build-Depends: debhelper (>= 9~), devscripts (>= 2.10), g++ (>= 4.4) | clang (>= 3.0), libboost-dev (>= 1.41) | libboost1.41-dev, cmake (>= 2.8), libusb-dev, pkg-config (>= 0.25), libxml2-dev,libboost-thread-dev,libboost-filesystem-dev,libboost-system-dev,libboost-date-time-dev,libboost-program-options-dev,libboost-test-dev,libboost-atomic-dev
-Standards-Version: 3.9.6
-Vcs-Git: git://git.debian.org/git/pkg-running/antpm.git
+Build-Depends: debhelper (>= 9~), devscripts (>= 2.10), g++ (>= 4.4) | clang (>= 3.0), libboost-dev (>= 1.41), cmake (>= 2.8), libusb-1.0-0-dev, pkg-config (>= 0.25), libxml2-dev,libboost-thread-dev,libboost-filesystem-dev,libboost-system-dev,libboost-date-time-dev,libboost-program-options-dev,libboost-test-dev,libboost-atomic-dev,libboost-exception-dev
+Standards-Version: 3.9.7
+Vcs-Git: git://anonscm.debian.org/pkg-running/antpm.git
 Vcs-Browser: http://git.debian.org/?p=pkg-running/antpm.git;a=summary
 
 Package: antpm

## antpm 1.19

=== 3rd_party/usbmon-6/Makefile ===
##
## usbmon - simple front-end for in-kernel usbmon
##

#CFLAGS += -Wall -Wp,-D_FORTIFY_SOURCE=2 -O2
CFLAGS += -Wall -Wshadow -Wmissing-declarations -Wmissing-prototypes
CFLAGS += -Wnested-externs -Wpointer-arith -Wpointer-arith -Wsign-compare
CFLAGS += -Wchar-subscripts -Wstrict-prototypes -Wformat=2 -Wtype-limits
CFLAGS += -Wp,-D_FORTIFY_SOURCE=2
CFLAGS += -O2

all: usbmon

usbmon: usbmon.o

usbmon.o: usbmon.c

clean:
	rm -f *.o usbmon

=== src/gant/CMakeLists.txt ===
# -*- mode: cmake; coding: utf-8-dos -*-


FIND_PACKAGE(LibXml2)
IF(NOT LIBXML2_FOUND)
  MESSAGE(FATAL_ERROR "libxml2 not found!")
ENDIF()

INCLUDE_DIRECTORIES(.)
INCLUDE_DIRECTORIES(${LIBXML2_INCLUDE_DIR})

SET(SRCS
  antdefs.h
  antlib.c
  antlib.h
  gant.c
)

ADD_EXECUTABLE(gant
  ${SRCS}
)
TARGET_LINK_LIBRARIES(gant
  m
  pthread
  ${LIBXML2_LIBRARIES}
)
INSTALL(TARGETS gant RUNTIME DESTINATION bin)

=== debian/changelog ===
antpm (1.19-6build1) focal; urgency=medium

  * No change rebuild against new boost1.71 ABI

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 03 Feb 2020 19:51:47 +0000

antpm (1.19-6) unstable; urgency=medium

  * QA upload.
  * Set Maintainer to Debian QA Group.  (See: #918906) (Closes: #899963)
  * Switch to autogenerated -dbgsym package.
  * Switch to debhelper-compat (= 12).
  * Migrate GIT repository to salsa.debian.org.

 -- Andreas Beckmann <anbe@debian.org>  Sun, 13 Jan 2019 13:43:50 +0100

antpm (1.19-5) unstable; urgency=low

  * Remove myself from Uploaders

 -- Christian Perrier <bubulle@debian.org>  Sat, 24 Mar 2018 07:32:30 +0100

antpm (1.19-4) unstable; urgency=medium

  * Team upload.

  [ RALOVICH, Kristof ]
  * debian: use Standards-Version 3.9.8

 -- Kristof Ralovich <ralovich@in.tum.de>  Sun, 18 Jun 2017 14:01:19 +0200

antpm (1.19-3) unstable; urgency=medium

  * Team upload.

  [ RALOVICH, Kristof ]
  * Change to unstable after release freeze ended.

 -- Kristof Ralovich <ralovich@in.tum.de>  Sun, 18 Jun 2017 13:42:52 +0200

antpm (1.19-2) experimental; urgency=medium

  * Team upload.

  [ RALOVICH, Kristof ]
  * Change to experimental to avoid messing with release freeze.

 --  Kristof Ralovich <ralovich@in.tum.de>  Sat, 01 Apr 2017 20:40:59 +0200

antpm (1.19-1) unstable; urgency=medium

  * Team upload.

  [ RALOVICH, Kristof ]
  * New upstream version 1.19.

 -- Kristof Ralovich <ralovich@in.tum.de>  Fri, 24 Mar 2017 21:03:30 +0100

=== debian/control ===
Source: antpm
Priority: optional
Section: utils
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian QA Group <packages@qa.debian.org>
Build-Depends:
 debhelper-compat (= 12),
 cmake (>= 2.8),
 devscripts (>= 2.10),
 libboost-atomic-dev,
 libboost-date-time-dev,
 libboost-dev (>= 1.41),
 libboost-exception-dev,
 libboost-filesystem-dev,
 libboost-program-options-dev,
 libboost-system-dev,
 libboost-test-dev,
 libboost-thread-dev,
 libusb-1.0-0-dev,
 libxml2-dev,
 pkg-config (>= 0.25),
Standards-Version: 3.9.8
Vcs-Git: https://salsa.debian.org/debian/antpm.git
Vcs-Browser: https://salsa.debian.org/debian/antpm

Package: antpm
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: ANT+ information retrieval client for Garmin GPS products
 This software uses the Garmin ANT+ proprietary USB keys and
 communication protocol to retrieve information (such as GPS traces)
 from some Garmin Forerunner watches such as Forerunner 405 and 310XT.
 .
 The underlying ANT+minus implements the ANT/ANT+/ANT-FS protocols to
 provide these tools: garmin-ant-downloader, antpm-downloader,
 antpm-fit2gpx, and antpm-usbmon2ant.
 .
 ANT+minus is a userspace implementation of a wire protocol similar
 to the ANT/ANT+/ANT-FS protocols. The goal is to be able to communicate
 with any ANT capable device in order to e.g. retrieve sports tracks. The
 C++ implementation is currently available under both Linux and win.
 Communication with watches other than the 310XT might work, but are
 untested. Please report your experience to help improving the software.
 .
 The software was originally named "gant" but renamed when packaged
 to avoid confusion with existing Java software.

## antpm 1.20

=== src/CMakeLists.txt ===
# -*- mode: cmake; coding: utf-8-dos -*-
CMAKE_MINIMUM_REQUIRED(VERSION 2.8.2)
IF(COMMAND CMAKE_POLICY)
  CMAKE_POLICY(SET CMP0003 NEW)
ENDIF(COMMAND CMAKE_POLICY)


PROJECT(antpm C CXX)

OPTION(USE_COVERAGE "use gcov" FALSE)
OPTION(USE_BOOST_TEST "use boost::test" FALSE)
OPTION(USE_BOOST_STATIC_LINK "link statically against boost" TRUE)
IF(MSVC)
  OPTION(USE_GANT "build gant" FALSE)
ELSE()
  OPTION(USE_GANT "build gant" TRUE)
ENDIF()

SET(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/cmake/")

# Set a default build type for single-configuration
# CMake generators if no build type is set.
IF(NOT CMAKE_CONFIGURATION_TYPES AND NOT CMAKE_BUILD_TYPE)
   SET(CMAKE_BUILD_TYPE Debug)
ENDIF(NOT CMAKE_CONFIGURATION_TYPES AND NOT CMAKE_BUILD_TYPE)
MESSAGE(STATUS "CMAKE_BUILD_TYPE=${CMAKE_BUILD_TYPE}")
MESSAGE(STATUS "CMAKE_CONFIGURATION_TYPES=${CMAKE_CONFIGURATION_TYPES}")

set(CMAKE_CXX_FLAGS_RELEASE        "${CMAKE_CXX_FLAGS_RELEASE} -DNDEBUG=1")
set(CMAKE_C_FLAGS_RELEASE          "${CMAKE_C_FLAGS_RELEASE} -DNDEBUG=1")

IF(MSVC)
	IF(NOT DEP_ROOT)
		SET(DEP_ROOT "DEP_ROOT-NOTFOUND" CACHE PATH "dependency root path")
	ENDIF()
	SET(LIBUSB_ROOT "${CMAKE_SOURCE_DIR}\\..\\3rd_party\\libusb-win32-bin-1.2.6.0\\")
	SET(BOOST_ROOT "${DEP_ROOT}\\boost_1_43_0" CACHE PATH "Boost PATH" )

  SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /MP")
  SET(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} /MD")
  ADD_DEFINITIONS(-D_CRT_SECURE_NO_WARNINGS)
  ADD_DEFINITIONS(-D_WIN32_WINNT=0x0500)
ENDIF()

IF(CMAKE_COMPILER_IS_GNUCXX OR "${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
  set(CMAKE_CXX_FLAGS                "${CMAKE_CXX_FLAGS} -fpermissive  -fms-extensions -std=c++1y -Wall")
  SET(CMAKE_CXX_FLAGS_RELWITHDEBINFO "${CMAKE_CXX_FLAGS_RELWITHDEBINFO} -O2 -g")
  SET(CMAKE_CXX_FLAGS_RELEASE        "${CMAKE_CXX_FLAGS_RELEASE} -O2")
  set(CMAKE_CXX_FLAGS_DEBUG          "${CMAKE_CXX_FLAGS_DEBUG} -O0 -g3 -ggdb3")
  set(CMAKE_C_FLAGS                  "${CMAKE_C_FLAGS} -std=c99 -pedantic -Wextra -Wall")
  set(CMAKE_C_FLAGS_DEBUG            "${CMAKE_C_FLAGS_DEBUG} -g3 -ggdb3")

  IF(USE_COVERAGE)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fprofile-arcs -ftest-coverage")
    set(CMAKE_EXE_LINKER_FLAGS
      "${CMAKE_EXE_LINKER_FLAGS} -fprofile-arcs -ftest-coverage")
  ENDIF()
ENDIF()

INCLUDE(Findlibusb-1.0)
IF(NOT LIBUSB_1_FOUND)
  MESSAGE(FATAL_ERROR "Could not find libusb-1.0")
ENDIF()

IF(USE_BOOST_STATIC_LINK)
  set(Boost_USE_STATIC_LIBS        ON)
  set(Boost_USE_STATIC_RUNTIME    ON)
ELSE()
  set(Boost_USE_STATIC_LIBS        OFF)
  set(Boost_USE_STATIC_RUNTIME    OFF)
  ADD_DEFINITIONS(-DBOOST_TEST_MAIN)
  ADD_DEFINITIONS(-DBOOST_TEST_DYN_LINK)
ENDIF()
set(Boost_USE_MULTITHREADED      ON)
FIND_PACKAGE(Boost 1.41.0 COMPONENTS thread unit_test_framework program_options system filesystem date_time atomic exception REQUIRED)
IF(NOT Boost_FOUND)
  MESSAGE(FATAL_ERROR "Boost not found!")
ENDIF()


INCLUDE_DIRECTORIES(.)
INCLUDE_DIRECTORIES(${Boost_INCLUDE_DIR})
INCLUDE_DIRECTORIES(${LIBUSB_1_INCLUDE_DIRS})

LINK_DIRECTORIES(${Boost_LIBRARY_DIRS})

IF(MSVC)
  ADD_DEFINITIONS(-D_CRT_NONSTDC_NO_WARNINGS)
  #set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} /NODEFAULTLIB:libboost_date_time-vc90-mt-s-1_43.lib /NODEFAULTLIB:libboost_thread-vc90-mt-s-1_43.lib /NODEFAULTLIB:libboost_program_options-vc90-mt-s-1_43.lib /NODEFAULTLIB:libboost_filesystem-vc90-mt-s-1_43.lib /NODEFAULTLIB:libboost_system-vc90-mt-s-1_43.lib")
ENDIF()

FILE(READ "${PROJECT_SOURCE_DIR}/VERSION" ANTPM_VERSION)
MESSAGE(STATUS "ANTPM_VERSION=\\\"${ANTPM_VERSION}\\\"")
ADD_DEFINITIONS(-DANTPM_VERSION=${ANTPM_VERSION})

SET(SRCS
  antdefs.hpp antdefs.cpp
  SmartPtrFwd.hpp   w_inttypes.h w_stdint.h stdintfwd.hpp
  common.hpp common.cpp
  AntMessage.hpp AntMessage.cpp
  AntChannel.hpp   AntChannel.cpp
  AntMessenger.hpp AntMessenger.cpp
  SerialUsb.hpp SerialUsb.cpp
  AntFr310XT.hpp AntFr310XT.cpp
  lqueue.hpp
  Serial.hpp Serial.cpp

  FIT.hpp FIT.cpp
  GPX.hpp GPX.cpp
  GarminConvert.hpp GarminConvert.cpp
  GarminPacketIntf.hpp GarminPacketIntf.cpp

  DeviceSettings.hpp DeviceSettings.cpp

  Log.hpp
  LazySingleton.hpp

  VERSION
)
IF(NOT WIN32)
  SET(SRCS
	  ${SRCS}
    SerialTty.hpp SerialTty.cpp
	  )
  SET(Boost_THREAD_LIBRARY "${Boost_THREAD_LIBRARY};pthread")
  SET(MY_ANTPM_LIBRARIES "stdc++;rt")
ENDIF()


ADD_LIBRARY(antpm
  ${SRCS}
)
TARGET_LINK_LIBRARIES(antpm
  ${Boost_DATE_TIME_LIBRARY}
  ${LIBUSB_1_LIBRARIES}
  ${Boost_THREAD_LIBRARY}
  ${Boost_ATOMIC_LIBRARY}
  ${Boost_EXCEPTION_LIBRARY}
  ${Boost_SYSTEM_LIBRARY}
  ${Boost_FILESYSTEM_LIBRARY}
  ${MY_ANTPM_LIBRARIES}
)

ADD_EXECUTABLE(antpm-usbmon2ant
  antpm-usbmon2ant.cpp
)
TARGET_LINK_LIBRARIES(antpm-usbmon2ant
  antpm
  ${Boost_PROGRAM_OPTIONS_LIBRARY}
)
INSTALL(TARGETS antpm-usbmon2ant RUNTIME DESTINATION bin)


ADD_EXECUTABLE(antpm-downloader
  antpm-downloader.cpp
)
TARGET_LINK_LIBRARIES(antpm-downloader
  antpm
  ${Boost_PROGRAM_OPTIONS_LIBRARY}
)
INSTALL(TARGETS antpm-downloader RUNTIME DESTINATION bin)


ADD_EXECUTABLE(antpm-fit2gpx
  antpm-fit2gpx.cpp
)
TARGET_LINK_LIBRARIES(antpm-fit2gpx
  antpm
  ${Boost_PROGRAM_OPTIONS_LIBRARY}
)
INSTALL(TARGETS antpm-fit2gpx RUNTIME DESTINATION bin)

add_custom_target(dist COMMAND ${CMAKE_MAKE_PROGRAM} package_source)

IF(USE_GANT)
  ADD_SUBDIRECTORY(gant)
ENDIF()

# set(CPACK_PACKAGE_VERSION_MAJOR "1")
# set(CPACK_PACKAGE_VERSION_MINOR "0")
# set(CPACK_SOURCE_GENERATOR "TGZ")
# set(CPACK_SOURCE_PACKAGE_FILE_NAME "${CMAKE_PROJECT_NAME}-${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}-src")
# MESSAGE(STATUS "${CPACK_SOURCE_IGNORE_FILES}")
# set(CPACK_SOURCE_IGNORE_FILES
#   "/build/;/.bzr/;~$;${CPACK_SOURCE_IGNORE_FILES};/CMakeLists.txt.user;/gpsbabel/;/gtest-1.6.0/")
# set(CPACK_DEBIAN_PACKAGE_MAINTAINER "Kristof Ralovich <tade60@freemail.hu>")
# set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "ANT+minus")
# set(CPACK_PACKAGE_DESCRIPTION "Userspace implementation of a wire protocol similar to the ANT/ANT+ protocols. The goal is to be able to communicate with the Forerunner 310XT watch, in order to retrieve sports tracks. Communication with other watches might work, please report your experiences to improve the software.")
# set(CPACK_DEBIAN_PACKAGE_DEPENDS "libstdc++6 (>=4.6.0)")
# #set(CPACK_DEBIAN_PACKAGE_DEPENDS "libstdc++6 (>=4.6.0), cmake, debhelper (>= 7), libboost-filesystem, libboost-system")
# #set(CPACK_DEBIAN_PACKAGE_CONTROL_EXTRA 	This variable allow advanced user to add custom script to the control.tar.gz (inside the .deb archive) 	${CMAKE_CURRENT_SOURCE_DIR}/postinst
# #set(CPACK_DEBIAN_PACKAGE_SECTION 	Package section (see http://packages.debian.org/stable/) 	Network
# #set(CPACK_DEBIAN_PACKAGE_VERSION 	Package version 	${CPACK_PACKAGE_VERSION}+lenny1
# INCLUDE(CPack)

IF(USE_BOOST_TEST)

  if(${VALGRIND_PREFIX})
    message(STATUS "Valgrind Prefix: ${VALGRIND_PREFIX}")
  endif()
  find_program(VALGRIND_PROGRAM NAMES valgrind PATH /usr/bin /usr/local/bin ${VALGRIND_PREFIX}/bin)
  IF(VALGRIND_PROGRAM)
    message(STATUS "Found Valgrind: ${VALGRIND_PROGRAM}")
    SET(MEMORYCHECK_COMMAND:FILEPATH=${VALGRIND_PROGRAM})
    # You can add additional options by specifying MEMORYCHECK_COMMAND_OPTIONS and MEMORYCHECK_SUPPRESSIONS_FILE. 
  ENDIF()

  enable_testing()
  ADD_SUBDIRECTORY(tests)
ENDIF()

=== src/tests/CMakeLists.txt ===
ADD_DEFINITIONS(-DUSE_BOOST_TEST=1)
ADD_DEFINITIONS(-DTEST_ROOT=\"${CMAKE_CURRENT_SOURCE_DIR}\")
MESSAGE(STATUS "TEST_ROOT=\"${CMAKE_CURRENT_SOURCE_DIR}\"")

ADD_EXECUTABLE(testDeviceSettings
  testDeviceSettings.cpp
)
TARGET_LINK_LIBRARIES(testDeviceSettings
  antpm
  ${Boost_PROGRAM_OPTIONS_LIBRARY}
  ${Boost_UNIT_TEST_FRAMEWORK_LIBRARY}
)

ADD_EXECUTABLE(testDateTime
  testDateTime.cpp
)
TARGET_LINK_LIBRARIES(testDateTime
  antpm
  ${Boost_PROGRAM_OPTIONS_LIBRARY}
  ${Boost_UNIT_TEST_FRAMEWORK_LIBRARY}
)


ADD_EXECUTABLE(sm1
  sm1.cpp
)
TARGET_LINK_LIBRARIES(sm1
  antpm
  ${Boost_UNIT_TEST_FRAMEWORK_LIBRARY}
)

ADD_EXECUTABLE(lq1
  lq1.cpp
)
TARGET_LINK_LIBRARIES(lq1
  antpm
  ${Boost_UNIT_TEST_FRAMEWORK_LIBRARY}
)


IF(VALGRIND_PROGRAM)
  function(add_my_test name binary)
    #set(memcheck_command "${CMAKE_MEMORYCHECK_COMMAND} ${CMAKE_MEMORYCHECK_COMMAND_OPTIONS}")
    #separate_arguments(memcheck_command)
    add_test(${name} ${binary} ${ARGN})
    add_test(memcheck_${name} ${VALGRIND_PROGRAM} --leak-check=full ./${binary} ${ARGN})
  endfunction()

  function(set_memcheck_test_properties name)
    set_tests_properties(${name} ${ARGN})
    set_tests_properties(memcheck_${name} ${ARGN})
  endfunction()
ELSE()
  function(ADD_MY_TEST name binary)
    add_test(${name} ${binary} ${ARGN})
  endfunction()
ENDIF()

ADD_MY_TEST(testDeviceSettings1 testDeviceSettings)

ADD_MY_TEST(testDateTime1 testDateTime)

ADD_MY_TEST(testDeviceSettings2 testDeviceSettings --help)

ADD_MY_TEST(testDateTime2 testDateTime --help)

#ADD_MY_TEST(testDownload ../antpm-downloader)

ADD_MY_TEST(testFit2Gpx ../antpm-fit2gpx)

ADD_MY_TEST(testUsbmon2AntParse  ../antpm-usbmon2ant --op parse  ${CMAKE_CURRENT_SOURCE_DIR}/2012_12_21_antagent1.usbmon)
ADD_MY_TEST(testUsbmon2AntDump   ../antpm-usbmon2ant --op dump   ${CMAKE_CURRENT_SOURCE_DIR}/2012_12_21_antagent1.usbmon)
ADD_MY_TEST(testUsbmon2AntUsbmon ../antpm-usbmon2ant --op usbmon ${CMAKE_CURRENT_SOURCE_DIR}/2012_12_21_antagent1.usbmon)
ADD_MY_TEST(testUsbmon2AntFilter ../antpm-usbmon2ant --op filter ${CMAKE_CURRENT_SOURCE_DIR}/2012_12_21_antagent1.usbmon)
ADD_MY_TEST(testUsbmon2AntCount  ../antpm-usbmon2ant --op count  ${CMAKE_CURRENT_SOURCE_DIR}/2012_12_21_antagent1.usbmon)


ADD_MY_TEST(testsm1 sm1)
ADD_MY_TEST(testlq1 lq1)

=== debian/changelog ===
antpm (1.20-1) unstable; urgency=medium

  [ RALOVICH, Kristof ]
  * new upstream release
  * fixes segfault and closes LP: #1805997
  * adopt package (Closes: #918906)
  * add watch file

  [ Andreas Beckmann ]
  * Add debian/upstream/metadata.
  * Set Rules-Requires-Root: no.

  [ Debian Janitor ]
  * Remove constraints unnecessary since stretch.
    + Build-Depends: Drop versioned constraint on cmake, devscripts and
      pkg-config.
  * Remove constraints unnecessary since buster.
    + Build-Depends: Drop versioned constraint on libboost-dev.

 -- Kristóf Ralovich <tade60@freemail.hu>  Mon, 08 Nov 2021 11:59:37 +0100

=== debian/control ===
--- 
+++ 
@@ -1,15 +1,14 @@
 Source: antpm
 Priority: optional
 Section: utils
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian QA Group <packages@qa.debian.org>
+Maintainer: Kristóf Ralovich <tade60@freemail.hu>
 Build-Depends:
  debhelper-compat (= 12),
- cmake (>= 2.8),
- devscripts (>= 2.10),
+ cmake,
+ devscripts,
  libboost-atomic-dev,
  libboost-date-time-dev,
- libboost-dev (>= 1.41),
+ libboost-dev,
  libboost-exception-dev,
  libboost-filesystem-dev,
  libboost-program-options-dev,
@@ -18,10 +17,12 @@
  libboost-thread-dev,
  libusb-1.0-0-dev,
  libxml2-dev,
- pkg-config (>= 0.25),
+ pkg-config
+Rules-Requires-Root: no
 Standards-Version: 3.9.8
 Vcs-Git: https://salsa.debian.org/debian/antpm.git
 Vcs-Browser: https://salsa.debian.org/debian/antpm
+Homepage: https://github.com/ralovich/antpm
 
 Package: antpm
 Architecture: any

=== debian/rules ===
--- 
+++ 
@@ -6,6 +6,7 @@
 # endif
 
 export DH_VERBOSE=1
+export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 
 NUMCPUS=$(shell grep -c '^processor' /proc/cpuinfo)
 ifeq ($(NUMCPUS),0)
@@ -30,10 +31,6 @@
 override_dh_auto_build:
 	cd cmake-build && $(MAKE) -j$(NUMCPUS)
 
-override_dh_strip:
-	dh_strip --dbg-package=antpm-dbg
-	dh_strip -s --remaining-packages
-
 DESTDIR=../debian/antpm/
 override_dh_install:
 	cd cmake-build && $(MAKE) install DESTDIR=$(DESTDIR)

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/@PACKAGE@-$1\.tar\.gz/ \
  https://github.com/ralovich/antpm/tags .*/v?(\d\S+)\.tar\.gz

## antpm 1.21

=== CMakeLists.txt ===
--- 
+++ 
@@ -6,11 +6,12 @@
 
 
 PROJECT(antpm C CXX)
+set(CMAKE_CXX_STANDARD 14)
 
 OPTION(USE_COVERAGE "use gcov" FALSE)
 OPTION(USE_BOOST_TEST "use boost::test" FALSE)
 OPTION(USE_BOOST_STATIC_LINK "link statically against boost" TRUE)
-IF(MSVC)
+IF(MSVC OR APPLE)
   OPTION(USE_GANT "build gant" FALSE)
 ELSE()
   OPTION(USE_GANT "build gant" TRUE)
@@ -42,8 +43,8 @@
   ADD_DEFINITIONS(-D_WIN32_WINNT=0x0500)
 ENDIF()
 
-IF(CMAKE_COMPILER_IS_GNUCXX)
-  set(CMAKE_CXX_FLAGS                "${CMAKE_CXX_FLAGS} -fpermissive  -fms-extensions -std=c++0x -Wall")
+IF(CMAKE_COMPILER_IS_GNUCXX OR "${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
+  set(CMAKE_CXX_FLAGS                "${CMAKE_CXX_FLAGS} -fpermissive  -fms-extensions -std=c++1y -Wall")
   SET(CMAKE_CXX_FLAGS_RELWITHDEBINFO "${CMAKE_CXX_FLAGS_RELWITHDEBINFO} -O2 -g")
   SET(CMAKE_CXX_FLAGS_RELEASE        "${CMAKE_CXX_FLAGS_RELEASE} -O2")
   set(CMAKE_CXX_FLAGS_DEBUG          "${CMAKE_CXX_FLAGS_DEBUG} -O0 -g3 -ggdb3")
@@ -57,29 +58,39 @@
   ENDIF()
 ENDIF()
 
-INCLUDE(FindLIBUSB)
-IF(NOT LIBUSB_FOUND)
-  MESSAGE(FATAL_ERROR "Could not find LIBUSB")
+IF(MSVC)
+  INCLUDE(Findlibusb-1.0)
+  IF(NOT LIBUSB_1_FOUND)
+    MESSAGE(FATAL_ERROR "Could not find libusb-1.0")
+  ENDIF()
+ELSE()
+  find_package(PkgConfig REQUIRED)
+  pkg_check_modules(LIBUSB_1 REQUIRED libusb-1.0)
 ENDIF()
 
 IF(USE_BOOST_STATIC_LINK)
+    set(Boost_VERBOSE ON)
+    set(Boost_DEBUG ON)
   set(Boost_USE_STATIC_LIBS        ON)
+  set(Boost_USE_STATIC_RUNTIME    OFF)
 ELSE()
   set(Boost_USE_STATIC_LIBS        OFF)
+  set(Boost_USE_STATIC_RUNTIME    OFF)
+  ADD_DEFINITIONS(-DBOOST_TEST_MAIN)
+  ADD_DEFINITIONS(-DBOOST_TEST_DYN_LINK)
 ENDIF()
 set(Boost_USE_MULTITHREADED      ON)
-set(Boost_USE_STATIC_RUNTIME    OFF)
-FIND_PACKAGE(Boost 1.41.0 COMPONENTS thread unit_test_framework program_options system filesystem date_time REQUIRED)
-IF(NOT Boost_FOUND)
-  MESSAGE(FATAL_ERROR "Boost not found!")
-ENDIF()
+FIND_PACKAGE(Boost 1.41.0 COMPONENTS thread unit_test_framework program_options system filesystem date_time atomic exception REQUIRED)
+#IF(NOT Boost_FOUND)
+#  MESSAGE(FATAL_ERROR "Boost not found!")
+#ENDIF()
 
 
 INCLUDE_DIRECTORIES(.)
-INCLUDE_DIRECTORIES(${Boost_INCLUDE_DIR})
-INCLUDE_DIRECTORIES(${LIBUSB_INCLUDE_DIRS})
-
-LINK_DIRECTORIES(${Boost_LIBRARY_DIRS})
+#INCLUDE_DIRECTORIES(${Boost_INCLUDE_DIR})
+INCLUDE_DIRECTORIES(${LIBUSB_1_INCLUDE_DIRS})
+
+#LINK_DIRECTORIES(${Boost_LIBRARY_DIRS})
 
 IF(MSVC)
   ADD_DEFINITIONS(-D_CRT_NONSTDC_NO_WARNINGS)
@@ -116,11 +127,14 @@
 )
 IF(NOT WIN32)
   SET(SRCS
-	  ${SRCS}
-    SerialTty.hpp SerialTty.cpp
-	  )
+      ${SRCS}
+      SerialTty.hpp SerialTty.cpp
+      )
   SET(Boost_THREAD_LIBRARY "${Boost_THREAD_LIBRARY};pthread")
   SET(MY_ANTPM_LIBRARIES "stdc++")
+  IF(NOT APPLE)
+    SET(MY_ANTPM_LIBRARIES "${MY_ANTPM_LIBRARIES};rt")
+  ENDIF()
 ENDIF()
 
 
@@ -128,11 +142,13 @@
   ${SRCS}
 )
 TARGET_LINK_LIBRARIES(antpm
-  ${Boost_DATE_TIME_LIBRARY}
-  ${LIBUSB_LIBRARIES}
-  ${Boost_THREAD_LIBRARY}
-  ${Boost_SYSTEM_LIBRARY}
-  ${Boost_FILESYSTEM_LIBRARY}
+  Boost::date_time
+  ${LIBUSB_1_LIBRARIES}
+  Boost::thread
+  Boost::atomic
+  Boost::exception
+  Boost::system
+  Boost::filesystem
   ${MY_ANTPM_LIBRARIES}
 )
 
@@ -141,7 +157,7 @@
 )
 TARGET_LINK_LIBRARIES(antpm-usbmon2ant
   antpm
-  ${Boost_PROGRAM_OPTIONS_LIBRARY}
+  Boost::program_options
 )
 INSTALL(TARGETS antpm-usbmon2ant RUNTIME DESTINATION bin)
 
@@ -151,7 +167,7 @@
 )
 TARGET_LINK_LIBRARIES(antpm-downloader
   antpm
-  ${Boost_PROGRAM_OPTIONS_LIBRARY}
+  Boost::program_options
 )
 INSTALL(TARGETS antpm-downloader RUNTIME DESTINATION bin)
 
@@ -161,7 +177,7 @@
 )
 TARGET_LINK_LIBRARIES(antpm-fit2gpx
   antpm
-  ${Boost_PROGRAM_OPTIONS_LIBRARY}
+  Boost::program_options
 )
 INSTALL(TARGETS antpm-fit2gpx RUNTIME DESTINATION bin)

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -64,7 +64,7 @@
 
 ADD_MY_TEST(testDateTime2 testDateTime --help)
 
-ADD_MY_TEST(testDownload ../antpm-downloader)
+#ADD_MY_TEST(testDownload ../antpm-downloader)
 
 ADD_MY_TEST(testFit2Gpx ../antpm-fit2gpx)
 
@@ -75,5 +75,5 @@
 ADD_MY_TEST(testUsbmon2AntCount  ../antpm-usbmon2ant --op count  ${CMAKE_CURRENT_SOURCE_DIR}/2012_12_21_antagent1.usbmon)
 
 
-ADD_MY_TEST(testsm1 sm1)
+#ADD_MY_TEST(testsm1 sm1)
 ADD_MY_TEST(testlq1 lq1)

=== debian/changelog ===
antpm (1.21-3) unstable; urgency=medium

  [ Kristof Ralovich ]
  * debian/controls: standards version 4.7.0
  * debian: run tests too
  * debian: enable building package twice in a row

 -- Kristóf Ralovich <tade60@freemail.hu>  Sat, 11 Jan 2025 23:52:55 +0100

antpm (1.21-2) unstable; urgency=medium

  [ Kristof Ralovich ]
  * debian/rules: remove cmake-build folder during clean target
   (Closes: #1043951)

  [ Petter Reinholdtsen ]
  * antpm: Add Appstream metainfo announcing HW support
   (Closes: #1079380)

  [ Andreas Beckmann ]
  * Switch Build-Depends from obsolete pkg-config to pkgconf.

 -- Kristóf Ralovich <tade60@freemail.hu>  Fri, 20 Dec 2024 16:02:29 +0100

antpm (1.21-1) unstable; urgency=medium

  [ RALOVICH, Kristof ]
  * new upstream release, fixes gcc 13 build (Closes: #1037577)
  * linking against boost statically
  * switch to debhelper-compat (= 13)
  * use Standards-Version 4.6.2

  [ Helmut Grohne ]
  * Fix FTCBFS: Let dh_auto_configure pass cross flags to cmake.
    (Closes: #999884)

 -- Kristóf Ralovich <tade60@freemail.hu>  Mon, 31 Jul 2023 02:24:53 +0200

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Section: utils
 Maintainer: Kristóf Ralovich <tade60@freemail.hu>
 Build-Depends:
- debhelper-compat (= 12),
+ debhelper-compat (= 13),
  cmake,
  devscripts,
  libboost-atomic-dev,
@@ -17,9 +17,10 @@
  libboost-thread-dev,
  libusb-1.0-0-dev,
  libxml2-dev,
- pkg-config
+ pkgconf,
+ valgrind
 Rules-Requires-Root: no
-Standards-Version: 3.9.8
+Standards-Version: 4.7.0
 Vcs-Git: https://salsa.debian.org/debian/antpm.git
 Vcs-Browser: https://salsa.debian.org/debian/antpm
 Homepage: https://github.com/ralovich/antpm

=== debian/rules ===
--- 
+++ 
@@ -25,11 +25,18 @@
 	dh $@
 
 override_dh_auto_configure:
-	mkdir cmake-build
-	cd cmake-build && cmake ../src -DCMAKE_BUILD_TYPE=Release -DCMAKE_INSTALL_PREFIX=/usr -DCMAKE_C_FLAGS="${CMAKE_C_FLAGS} $(CFLAGS)" -DCMAKE_CXX_FLAGS="${CMAKE_CXX_FLAGS} $(CXXFLAGS)"
+	dh_auto_configure --sourcedirectory=src --builddirectory=cmake-build -- -DCMAKE_BUILD_TYPE=Release -DCMAKE_C_FLAGS="${CMAKE_C_FLAGS} $(CFLAGS)" -DCMAKE_CXX_FLAGS="${CMAKE_CXX_FLAGS} $(CXXFLAGS)" -DUSE_BOOST_TEST=TRUE
 
 override_dh_auto_build:
-	cd cmake-build && $(MAKE) -j$(NUMCPUS)
+	cd cmake-build && $(MAKE) -j$(NUMCPUS) VERBOSE=true
+
+override_dh_auto_test:
+	cd cmake-build && ctest -N && ctest -j$(NUMCPUS)
+
+override_dh_auto_clean:
+	dh_auto_clean
+	$(RM) src/tests/config_tmp.ini
+	$(RM) -r cmake-build
 
 DESTDIR=../debian/antpm/
 override_dh_install:
